#!/usr/bin/python3

import os
import sys
import uuid

if len(sys.argv) == 3:
    fquant, size = sys.argv[1:3]
    dquant, depth = None, None
elif len(sys.argv) == 5:
    fquant, size = sys.argv[1:3]
    dquant, depth = sys.argv[3:5]
else:
    print("Usar: gen_test_files.py file_quant sizeeach [dir_quant dir_depth]")
    exit()


class Creator(object):
    def __init__(self, fquant, size, dquant):
        self.fquant = fquant
        self.size = size
        self.dquant = dquant
        self.dcount = 0
        self.fcount = 0

    def create_files(self, basepath):
        """Create a lot of files."""
        for i in range(self.fquant):
            name = "testfile-" + str(uuid.uuid4())
            f = open(os.path.join(basepath, name), 'wb')
            f.write(os.urandom(self.size))
            f.close()
            self.fcount += 1

    def make_folders(self, depth, folderpath):
        """Create a tree."""
        for n in range(int(self.dquant)):
            newpath = os.path.join(folderpath, "testfolder-%04d" % n)
            os.mkdir(newpath)
            self.dcount += 1
            if depth > 1:
                self.make_folders(depth - 1, newpath)
            else:
                self.create_files(newpath)


c = Creator(int(fquant), int(size), dquant)
if dquant is None:
    c.create_files(".")
else:
    c.make_folders(int(depth), ".")

print("Created:  %d dirs  %d files" % (c.dcount, c.fcount))
